using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using MeshVR;
using SimpleJSON;
using UnityEngine.PostProcessing;
using UnityEngine.Rendering;
using UnityEngine.UI;
using UnityEngine.Events;
namespace AnimeCellEffect_Beta_HuntingSuccubus
{
    public class SSSSkin_HuntingSuccubus : MVRScript
    {
		private Atom _person;
		private DAZCharacterSelector _selector;
        private DAZCharacter _character;
		DAZSkinV2 skin;
		
        JSONStorableFloat _BaseColor_Step;		
        JSONStorableFloat _BaseShade_Feather;		
        JSONStorableFloat _ShadeColor_Step;		
        JSONStorableFloat _1st2nd_Shades_Feather;		
        JSONStorableFloat _HighColor_Power;
        JSONStorableFloat _Outline_Width;
        JSONStorableColor _BaseColor;
        JSONStorableColor _1st_ShadeColor;		
        JSONStorableColor _2nd_ShadeColor;
        JSONStorableColor _Outline_Color;		
		
        JSONStorableFloat alpha;
        JSONStorableFloat artremvlatency;
        JSONStorableFloat artremvpixbias;
        JSONStorableFloat blurIterations;		
        JSONStorableFloat scatterDistance;		
        JSONStorableFloat scatterIntensity;
        JSONStorableFloat softDepthBias;
        JSONStorableFloat affectDirect;
        JSONStorableFloat _Tess ;		
        JSONStorableFloat _TessPhong   ;	
        JSONStorableFloat _TessellationUniform;
		JSONStorableUrl lookUpTable;
		JSONStorableUrl TextureLoaderFaceUrl;		
		JSONStorableUrl TextureLoaderTorsoUrl;		
		JSONStorableUrl TextureLoaderLimbsUrl;		
		JSONStorableUrl TextureLoaderGensUrl;		
		JSONStorableUrl storable1FaceUrl;
		JSONStorableUrl storable1TorsoUrl;
		JSONStorableUrl storable1LimbsUrl;
		JSONStorableUrl storable1GensUrl;
		
		Texture2D textureFace;
		Texture2D textureTorso;
		Texture2D textureLimbs;
		Texture2D textureGens;

		
        JSONStorableBool enableSSS;
        JSONStorableBool enableSSSCompare;
		JSONStorableBool enableScreenshotCamera;		
		JSONStorableBool enableWindowCamera;
		JSONStorableBool enableWindowCameraHUD;		
		JSONStorableBool enableTessellation;		
		JSONStorableBool diffuseSSS;
		JSONStorableBool decalSSS;		
		
        JSONStorableUrl loadedShaderPath = new JSONStorableUrl("shader", "");
		bool nowStarted = false;
		bool directionalLightFound = false;
        bool loadedAssetBundle;
        bool isLoading;
        int retryAttempts;
		int timer;
		int timer2;
		static int scatteringColorID;
      	private static readonly string defaultDir = "Custom/Scripts/Hunting-Succubus/";
        private static readonly string BUNDLE_NAME = "AnimeSkinHuntSucMod.assetbundle";
        private static readonly string BUNDLE_NAMEWIP = "AnimeSkinHuntSucModWIP.assetbundle";

        protected List<Material[]> ourMaterials = new List<Material[]>();
		public Material test;
        protected Shader shader;
        protected Shader wrapshader;		
		protected Shader sssshader;
		protected Shader maskShader;
		protected Shader copyDepthShader;
		protected Shader sssshader2;
		protected Shader maskShader2;
		protected Shader copyDepthShader2;
		protected Shader tessShader;		
		protected Shader tessShader2;
		protected Shader tessShader3;		
		protected Shader tessShader4;
		protected Shader tessShader5;
		protected Shader shadowShader;
		protected Shader skyshop;		
		
		public	Material maskmaterial;
		public	Material blurshadermaterial;
		public	Material copyDepthShadermaterial;
		public	Material maskmaterial2;
		public	Material blurshadermaterial2;
		public	Material copyDepthShadermaterial2;	
		Material[] SavedMaterials;
		Material[] SavedMaterialsTemp;
	
        public override void Init()
        {
            try {	
			    if (containingAtom?.type != "Person")
				{
                SuperController.LogError($"This plugin only works on Person atoms");
                DestroyImmediate(this);
                return;
				}
			    _person = containingAtom;
				_selector = _person.GetComponentInChildren<DAZCharacterSelector>();
				_character = _selector.selectedCharacter;
/*                 enableSSS = new JSONStorableBool("Enable Subsurface Scattering", true);
                RegisterBool(enableSSS);
                CreateToggle(enableSSS, false);
				
				diffuseSSS = new JSONStorableBool("Blend Diffuse Tex with SSS Tex", true);
                RegisterBool(diffuseSSS);
                CreateToggle(diffuseSSS, false);				

                enableSSSCompare = new JSONStorableBool("Compare Skin", false, (bool _) => toggleCompare());
                RegisterBool(enableSSSCompare);
                CreateToggle(enableSSSCompare, false);		

				
				enableTessellation = new JSONStorableBool("Tessellation", false);
                RegisterBool(enableTessellation);
                CreateToggle(enableTessellation, false);
				
				enableScreenshotCamera = new JSONStorableBool("SSS on Screenshot Camera", true);
                RegisterBool(enableScreenshotCamera);
                CreateToggle(enableScreenshotCamera, false);
				
				enableWindowCamera = new JSONStorableBool("SSS on Window Camera", false);
                RegisterBool(enableWindowCamera);
                CreateToggle(enableWindowCamera, false);	
				
				enableWindowCameraHUD = new JSONStorableBool("SSS on Window Camera HUD", false);
                RegisterBool(enableWindowCameraHUD);
                CreateToggle(enableWindowCameraHUD, false);	 */	
                _BaseColor = new JSONStorableColor("Base Color", HSVColorPicker.RGBToHSV(1f, 1f, 1f));
                RegisterColor(_BaseColor);
                CreateColorPicker(_BaseColor, false);
				
                _1st_ShadeColor = new JSONStorableColor("1st Shadow Color", HSVColorPicker.RGBToHSV(0.5f, 0.5f, 0.5f));
                RegisterColor(_1st_ShadeColor);
                CreateColorPicker(_1st_ShadeColor, false);
				
                _2nd_ShadeColor = new JSONStorableColor("2nd Shadow Color", HSVColorPicker.RGBToHSV(0.25f, 0.25f, 0.25f));
                RegisterColor(_2nd_ShadeColor);
                CreateColorPicker(_2nd_ShadeColor, false);				
				
                _Outline_Color = new JSONStorableColor("Edge Color", HSVColorPicker.RGBToHSV(0f, 0f, 0f));
                RegisterColor(_Outline_Color);
                CreateColorPicker(_Outline_Color, false);
				
				_BaseColor_Step = new JSONStorableFloat("BaseColor Step", 0.5f, 0.0001f, 1f, true, true);
				RegisterFloat(_BaseColor_Step);
				CreateSlider(_BaseColor_Step, true);				
				
				_BaseShade_Feather = new JSONStorableFloat("Shadow Softness", 0f, 0.0001f, 1f, true, true);
				RegisterFloat(_BaseShade_Feather);
				CreateSlider(_BaseShade_Feather, true);				
				
				_ShadeColor_Step = new JSONStorableFloat("Shadow  Step", 0.2f, 0f, 1f, true, true);
				RegisterFloat(_ShadeColor_Step);
				CreateSlider(_ShadeColor_Step, true);				
				
				_1st2nd_Shades_Feather = new JSONStorableFloat("1st/2nd Shadow Softness", 0.5f, 0.0001f, 1f, true, true);
				RegisterFloat(_1st2nd_Shades_Feather);
				CreateSlider(_1st2nd_Shades_Feather, true);				
				
				_HighColor_Power = new JSONStorableFloat("HighLight Power", 0.4f, 0f, 1f, true, true);
				RegisterFloat(_HighColor_Power);
				CreateSlider(_HighColor_Power, true);
								
				_Outline_Width = new JSONStorableFloat("Edge Width", 2f, 0f, 4f, true, true);
				RegisterFloat(_Outline_Width);
				CreateSlider(_Outline_Width, true);
				
/* 				artremvpixbias = new JSONStorableFloat("Artifact Removal Pixel Bias", 2f, 1f, 100f, true, true);
				RegisterFloat(artremvpixbias);
				CreateSlider(artremvpixbias, true);	 */	
				
/* 			TextureLoader();	
			
			UIDynamicTextField textfieldversion = CreateTextField(new JSONStorableString("Info", "SubsurfaceScatteringSkin by HuntingSuccubus Beta 10"));
			textfieldversion.height = 12;
			//textfieldversion.textColor = Color.gray;
			UIDynamicTextField textfieldupdate1 = CreateTextField(new JSONStorableString("Info", "Tight Cloth with Tessellation may create artifact,set Cloth Material's render queue to 2550, ***It will also disable Cloth's Shadow"));
			textfieldupdate1.textColor = Color.gray;
			UIDynamicTextField textfieldupdate2 = CreateTextField(new JSONStorableString("Info", "enabling SSS on Window Camera may show blinking artifact but during video recording it will not show."));
			textfieldupdate2.textColor = Color.gray; */			
/* 				_Tess  = new JSONStorableFloat("_Tess", 4.0f, 0.0f, 8.0f, true, true);
				RegisterFloat(_Tess);
				CreateSlider(_Tess, true);

				_TessPhong    = new JSONStorableFloat("_TessPhong ", 1.2f, 0.0f, 4.0f, true, true);
				RegisterFloat(_TessPhong );
				CreateSlider(_TessPhong , true);

				_TessellationUniform   = new JSONStorableFloat("_TessellationUniform", 10.0f, 1.0f, 64.0f, true, true);
				RegisterFloat(_TessellationUniform);
				CreateSlider(_TessellationUniform, true); */
				wrapshader = Shader.Find("Custom/Subsurface/TransparentGlossNMNoCullSeparateAlphaComputeBuff");
				StartCoroutine(LoadShaderAndInit());
				
				timer=1;
				timer2=1;
                }
             catch (Exception e) {
                SuperController.LogError("Exception caught: " + e);
            }
        }
		
	void fixScalp()
	{var allWraps = containingAtom.gameObject.GetComponentsInChildren<DAZSkinWrap>(false);
		foreach (var wrap in allWraps) 
		{if (wrap.ToString().Contains("Scalp")) 
			{wrap.GPUmaterials[0].renderQueue = 2504;}					   
		}
	}
		
	protected IEnumerator nowStart()
	{	
		if(isLoading)
		StartCoroutine(LoadShaderAndInit());
		else
	  {
		SavedMaterials = new Material[skin.GPUmaterials.Length];
		SavedMaterialsTemp = new Material[skin.GPUmaterials.Length];
		for(int i = 0; i < skin.GPUmaterials.Length; i++)
		SavedMaterials[i] = new Material(skin.GPUmaterials[i]);
		//SavedMaterials = skin.GPUmaterials;
		//fixScalp();
		nowStarted = true;
/* 		foreach (Light light in FindObjectsOfType<Light>())
		{
		 if(light.type==LightType.Point)
			light.shadowBias = 0f;
		 if(light.type==LightType.Directional)
			{if(light.enabled)
			directionalLightFound = true;}
		}
		if(!directionalLightFound)
		SuperController.LogMessage("No enabled Directional Light found!!! SSS Skin require atleast one Directional Light to function."); */
	  }
	  yield return new WaitForEndOfFrame();
	}	
		
   void Update() // Updating Matterial Buffers
    {if (nowStarted)	
		{
			foreach (Material mat in skin.GPUmaterials){
        	if (mat != null && mat.name != "EyeReflection-1" && mat.name != "EyeReflection" && mat.name != "Irises" && mat.name != "Irises-1" && mat.name != "Eyelashes" && mat.name != "Eyelashes-1" && mat.name != "Cornea-1" && mat.name != "Cornea"&& mat.name != "Pupils-1"&& mat.name != "Pupils" && mat.name != "Tear" && mat.name != "Tear-1" && mat.name != "Teeth-1" && mat.name != "Teeth" && mat.name != "Tongue" && mat.name != "Tongue-1" && mat.name != "InnerMouth-1" && mat.name != "InnerMouth") {
			if(mat.shader.name != "Custom/Subsurface/TransparentGlossNMNoCullSeparateAlphaComputeBuff")
        	mat.shader = shader;
			mat.SetColor("_BaseColor", _BaseColor.colorPicker.currentColor);	
			mat.SetColor("_1st_ShadeColor", _1st_ShadeColor.colorPicker.currentColor);	
			mat.SetColor("_2nd_ShadeColor", _2nd_ShadeColor.colorPicker.currentColor);			
			mat.SetColor("_Outline_Color", _Outline_Color.colorPicker.currentColor);			
			mat.SetFloat("_BaseColor_Step", _BaseColor_Step.val);
			mat.SetFloat("_BaseShade_Feather", _BaseShade_Feather.val);	
			mat.SetFloat("_Use_BaseAs1st", 1f);			
		
			mat.SetFloat("_ShadeColor_Step", _ShadeColor_Step.val);
			mat.SetFloat("_1st2nd_Shades_Feather", _1st2nd_Shades_Feather.val);	
		
			mat.SetFloat("_HighColor_Power", _HighColor_Power.val);	
	
			mat.SetFloat("_Outline_Width", _Outline_Width.val);			

			
			}
			skin.BroadcastMessage("OnApplicationFocus", true);
        	}	
			foreach (DAZSkinWrap wrap in containingAtom.gameObject.GetComponentsInChildren<DAZSkinWrap>(false)){
			foreach (var mo in wrap.GetComponents<DAZSkinWrapMaterialOptions>()) {
			foreach (var i in mo.paramMaterialSlots){
			wrap.GPUmaterials[i].shader = shader;
			wrap.GPUmaterials[i].SetColor("_BaseColor", _BaseColor.colorPicker.currentColor);	
			wrap.GPUmaterials[i].SetColor("_1st_ShadeColor", _1st_ShadeColor.colorPicker.currentColor);	
			wrap.GPUmaterials[i].SetColor("_2nd_ShadeColor", _2nd_ShadeColor.colorPicker.currentColor);			
			wrap.GPUmaterials[i].SetColor("_Outline_Color", _Outline_Color.colorPicker.currentColor);			
			wrap.GPUmaterials[i].SetFloat("_BaseColor_Step", _BaseColor_Step.val);
			wrap.GPUmaterials[i].SetFloat("_BaseShade_Feather", _BaseShade_Feather.val);	
			wrap.GPUmaterials[i].SetFloat("_Use_BaseAs1st", 1f);			
			wrap.GPUmaterials[i].SetFloat("_ShadeColor_Step", _ShadeColor_Step.val);
			wrap.GPUmaterials[i].SetFloat("_1st2nd_Shades_Feather", _1st2nd_Shades_Feather.val);	
			wrap.GPUmaterials[i].SetFloat("_HighColor_Power", _HighColor_Power.val);	
			wrap.GPUmaterials[i].SetFloat("_Outline_Width", _Outline_Width.val);
			
			}
			wrap.BroadcastMessage("OnApplicationFocus", true);
			}
			}

		}
	}


	

	void OnEnable()
	{
			
	}

	void OnDisable()
	{
			for(int i = 0; i < skin.GPUmaterials.Length; i++)
			{
				
			SavedMaterialsTemp[i] = new Material(SavedMaterials[i]);
			skin.GPUmaterials[i] = SavedMaterialsTemp[i];
			}
		skin.BroadcastMessage("OnApplicationFocus", true);
			foreach (DAZSkinWrap wrap in containingAtom.gameObject.GetComponentsInChildren<DAZSkinWrap>(false))
			{
				foreach (var mo in wrap.GetComponents<DAZSkinWrapMaterialOptions>()) {
                    foreach (var i in mo.paramMaterialSlots) {
						                     
						wrap.GPUmaterials[i].shader = wrapshader;	
						
						
                   }
				   wrap.BroadcastMessage("OnApplicationFocus", true);
				}
			}
		
		
	}		
	
	void toggleCompare()
	{
		if(enableSSSCompare.val)
		{
		QueueLoadTexture(GetPluginPath()+"/CompareSkin.png",FaceTextureLoaded);		
		QueueLoadTexture(GetPluginPath()+"/CompareSkin.png",TorsoTextureLoaded);	
		QueueLoadTexture(GetPluginPath()+"/CompareLimbsSkin.png",LimbsTextureLoaded);
		QueueLoadTexture(GetPluginPath()+"/CompareSkin.png",GensTextureLoaded);		
		}
		else
		{
		QueueLoadTexture(storable1FaceUrl.val,FaceTextureLoaded);		
		QueueLoadTexture(storable1TorsoUrl.val,TorsoTextureLoaded);
		QueueLoadTexture(storable1LimbsUrl.val,LimbsTextureLoaded);		
		QueueLoadTexture(storable1GensUrl.val,GensTextureLoaded);
		}
	}	
	void TextureLoader()
	{
		string defaultFaceTex = GetPluginPath() + "/DefaultSSSTex.png";
		string defaultTorsoTex = GetPluginPath() + "/DefaultSSSTex.png";		
		string defaultLimbsTex = GetPluginPath() + "/DefaultSSSTex.png";		
		string defaulGenstTex = GetPluginPath() + "/DefaultSSSTex.png";		
	
		
		storable1FaceUrl = new JSONStorableUrl("Load Face Subdermis Texture", defaultFaceTex, (string url) => { QueueLoadTexture(url,FaceTextureLoaded); }, "jpg|png|tif|tiff");
		RegisterUrl(storable1FaceUrl);
		UIDynamicButton button1 = CreateButton("Load Face Subdermis Texture", false);
		storable1FaceUrl.suggestedPath = defaultDir;
		storable1FaceUrl.RegisterFileBrowseButton(button1.button);
		
		storable1TorsoUrl = new JSONStorableUrl("Load Torso Subdermis Texture", defaultTorsoTex, (string url) => { QueueLoadTexture(url,TorsoTextureLoaded); }, "jpg|png|tif|tiff");
		RegisterUrl(storable1TorsoUrl);
		UIDynamicButton button2 = CreateButton("Load Torso Subdermis Texture", false);
		storable1TorsoUrl.suggestedPath = defaultDir;
		storable1TorsoUrl.RegisterFileBrowseButton(button2.button);		
		
		storable1LimbsUrl = new JSONStorableUrl("Load Limbs Subdermis Texture", defaultLimbsTex, (string url) => { QueueLoadTexture(url,LimbsTextureLoaded); }, "jpg|png|tif|tiff");
		RegisterUrl(storable1LimbsUrl);
		UIDynamicButton button3 = CreateButton("Load Limbs Subdermis Texture", false);
		storable1LimbsUrl.suggestedPath = defaultDir;
		storable1LimbsUrl.RegisterFileBrowseButton(button3.button);		
		
		storable1GensUrl = new JSONStorableUrl("Load Gens Subdermis Texture", defaulGenstTex, (string url) => { QueueLoadTexture(url,GensTextureLoaded); }, "jpg|png|tif|tiff");
		RegisterUrl(storable1GensUrl);
		UIDynamicButton button4 = CreateButton("Load Gens Subdermis Texture", false);
		storable1GensUrl.suggestedPath = defaultDir;
		storable1GensUrl.RegisterFileBrowseButton(button4.button);		
		
		
		
		//SetupTexture2DChooser(this, "Load Face Subdermis Texture", defaultFaceTex, false, FaceTextureLoaded);
		//SetupTexture2DChooser(this, "Load Torso Subdermis Texture", defaultTorsoTex, false, TorsoTextureLoaded);		
		//SetupTexture2DChooser(this, "Load Limbs Subdermis Texture", defaultLimbsTex, false, LimbsTextureLoaded);		
		//SetupTexture2DChooser(this, "Load Gens Subdermis Texture", defaulGenstTex, false, GensTextureLoaded);		
		
		QueueLoadTexture(defaultFaceTex,FaceTextureLoaded);		
		QueueLoadTexture(defaultTorsoTex,TorsoTextureLoaded);		
		QueueLoadTexture(defaultLimbsTex,LimbsTextureLoaded);		
		QueueLoadTexture(defaulGenstTex,GensTextureLoaded);				
	}

	public static JSONStorableUrl SetupTexture2DChooser(MVRScript self, string label, string defaultValue, bool rightSide, TextureSetCallback callback)
	{
			JSONStorableUrl storable = new JSONStorableUrl(label, defaultValue, (string url) => { QueueLoadTexture(url,callback); }, "jpg|png|tif|tiff");
			self.RegisterUrl(storable);
			//SuperController.LogError(defaultValue);	
			UIDynamicButton button = self.CreateButton(label, false);
			storable.suggestedPath = defaultDir;
			storable.RegisterFileBrowseButton(button.button);
			return storable;
	}



		private static void QueueLoadTexture(string url,TextureSetCallback callback)
		{	
			if (ImageLoaderThreaded.singleton == null)
			{
				return;
			}
			if (string.IsNullOrEmpty(url))
			{	
				return;
			}
			ImageLoaderThreaded.QueuedImage queuedImage = new ImageLoaderThreaded.QueuedImage();
			queuedImage.imgPath = url;	
			//SuperController.LogError(url);	
			queuedImage.forceReload = true;
			queuedImage.skipCache = true;
			queuedImage.compress = false;
			queuedImage.createMipMaps = false;
			queuedImage.isNormalMap = false;			
			queuedImage.linear = true;
			queuedImage.createAlphaFromGrayscale = false;
			queuedImage.createNormalFromBump = false;
			queuedImage.bumpStrength = 1.0f;
			queuedImage.isThumbnail = false;
			queuedImage.fillBackground = false;
			queuedImage.invert = false;
			queuedImage.callback = (ImageLoaderThreaded.QueuedImage qi) =>
			{
				Texture2D tex = qi.tex;
				if (tex != null)
				{	
					tex.wrapMode = TextureWrapMode.Clamp;
					tex.filterMode = FilterMode.Trilinear;
					tex.anisoLevel = 0;
				}						
				callback(tex);
			};
			ImageLoaderThreaded.singleton.QueueImage(queuedImage);			
		}

	public delegate void TextureSetCallback(Texture2D tex);
	
			private void FaceTextureLoaded(Texture2D tex)
			{		
				textureFace = tex;
			}

 			private void TorsoTextureLoaded(Texture2D tex)
			{	
				textureTorso = tex;
			}      		
		
			private void LimbsTextureLoaded(Texture2D tex)
			{		
				textureLimbs = tex;
			}		
		
			private void GensTextureLoaded(Texture2D tex)
			{	
			textureGens = tex;
			}		
		
		
		
		
		
		
		
		
//////////////////////  AssetLoader/////////////////////////////////////////
	
	
       class LoadAssetBundle : CustomYieldInstruction {
            AssetLoader.AssetBundleFromFileRequest req;
            private bool done;
            // We can't write the type AssetBundle, but we can call methods on it. lolwut C#
            public bool success => req.assetBundle != null;
            public T GetAsset<T>(string name) where T : UnityEngine.Object
            {
                return req.assetBundle?.LoadAsset<T>(name);
            }
            public LoadAssetBundle(string url)
            {
                req = new AssetLoader.AssetBundleFromFileRequest {
                    path = url,
                    callback = _ => {
                        done = true;
                        if (req.assetBundle == null)
                            AssetLoader.DoneWithAssetBundleFromFile(req.path);
                    }
                };
                AssetLoader.QueueLoadAssetBundleFromFile(req);
            }
            public override bool keepWaiting => !done;
        }
	        private IEnumerator AttemptLoadShader(string url)
        {              
            if (shader != null)
                yield break;
            var request = new LoadAssetBundle(url);
            yield return StartCoroutine(request);
            if (!request.success)
                yield break;
            shader = request.GetAsset<Shader>("Assets/Toon/Shader/Toon_DoubleShadeWithFeather.shader");
			//shader = request.GetAsset<Shader>("Assets/Marmoset/Shader/Beta/Skin/skyshop.shader");
			sssshader = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/CP_SSSSS_Shader.shader");
            maskShader = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/CP_SSSSS_Mask.shader");			
            copyDepthShader = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/CP_SSSSS_BlitDepthTextureToDepth.shader");
            sssshader2 = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/CP_VR_SSSSS_Shader.shader");
            maskShader2 = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/VAMCP_VR_SSSSS_Mask.shader");			
            copyDepthShader2 = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/VAMCP_SSSSS_BlitDepthTextureToDepth.shader");	
            tessShader = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/GeneratedFromSurface-TessellationBumpedSpecularSmooth2222.shader");
            tessShader2 = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/TessellationBumpedSpecularSmooth2222.shader");
            tessShader3 = request.GetAsset<Shader>("Assets/Shaders/TessellationSample.shader");
			
			if(Camera.main.name=="Camera (eye)"||Camera.main.name=="CenterEyeAnchor")
			{
            tessShader4 = request.GetAsset<Shader>("Assets/Shaders/GeneratedFromSurface-TessellationSample3.shader");
			}
			else
			{
            tessShader4 = request.GetAsset<Shader>("Assets/Shaders/GeneratedFromSurface-TessellationSample422.shader");
			}
		
			shadowShader = request.GetAsset<Shader>("Assets/Shaders/UnlitWithShadowcaster2.shader");
			skyshop = request.GetAsset<Shader>("Assets/Marmoset/Shader/Beta/Skin/skyshop2.shader");		
			
			maskmaterial = new Material(maskShader);
			maskmaterial.SetColor("ScatteringColor", Color.red);
			blurshadermaterial = new Material(sssshader);
			copyDepthShadermaterial = new Material(copyDepthShader);
			maskmaterial2 = new Material(maskShader2);
			maskmaterial2.SetColor("ScatteringColor", Color.red);
			blurshadermaterial2 = new Material(sssshader2);
			copyDepthShadermaterial2 = new Material(copyDepthShader2);
		
			
            if (shader != null) {
                loadedShaderPath.val = url;
                loadedAssetBundle = true;
            } else {
                SuperController.LogError("Not found location in  assetbundle,this error occurs when diff plugin version is used in same session(save scene and restart vam). User should extract VAR package and select script from there!");
                AssetLoader.DoneWithAssetBundleFromFile(url);
            }
        }
		
		
        string GetPluginPath() // basically straight from VAMDeluxe's Dollmaster
        {
            string pluginId = this.storeId.Split('_')[0];
            string pathToScriptFile = manager.GetJSON(true, true)["plugins"][pluginId].Value;
            string pathToScriptFolder = pathToScriptFile.Substring(0, pathToScriptFile.LastIndexOfAny(new char[] { '/', '\\' }));
            return pathToScriptFolder;
        }		
		
	     protected IEnumerator LoadShaderAndInit()
        {
			yield return new WaitForEndOfFrame();
			if (shader == null) 
			{
                if (loadedShaderPath.val != "")
                    yield return AttemptLoadShader(loadedShaderPath.val);
				//SuperController.LogError("path"+GetPluginPath());

              // yield return AttemptLoadShader($"Custom/Scripts/Hunting-Succubus/{BUNDLE_NAMEWIP}");
			    yield return AttemptLoadShader($"{GetPluginPath()}/{BUNDLE_NAMEWIP}");
              yield return AttemptLoadShader($"{GetPluginPath()}/{BUNDLE_NAME}");
				
                if (shader == null || maskShader == null || copyDepthShader == null) 
				{
                    SuperController.LogError("main.Failed to load shader,this error occurs when diff plugin version is used in same session(save scene and restart vam). User can extract VAR package and select script from there!");
                    yield break;
                }
            }
			skin = _character.skin;
			
			if (skin == null)
			isLoading = true;
			else
			isLoading = false;
		
			StartCoroutine(QueueRescan());
        }	

	  private IEnumerator QueueRescan()
        {
         if (retryAttempts < 5 || (isLoading && retryAttempts < 200)) 
			{
             yield return new WaitForSeconds(0.2f);
             retryAttempts++;
             yield return nowStart();
            }
        }
		
		
    }

}